Index: LMDZ6/trunk/libf/phylmd/cloudth_mod.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/cloudth_mod.F90	(revision 4113)
+++ LMDZ6/trunk/libf/phylmd/cloudth_mod.F90	(revision 4114)
@@ -1549,6 +1549,6 @@
       USE ioipsl_getin_p_mod, ONLY : getin_p
       USE phys_output_var_mod, ONLY : cloudth_sth,cloudth_senv,cloudth_sigmath,cloudth_sigmaenv
-      USE lscp_tools_mod, ONLY: CALC_QSAT_ECMWF
-      USE phys_local_var_mod, ONLY : qlth, qith, qsith
+      USE lscp_tools_mod, ONLY: CALC_QSAT_ECMWF, FALLICE_VELOCITY
+      USE phys_local_var_mod, ONLY : qlth, qith, qsith, with
 
       IMPLICIT NONE
@@ -1596,5 +1596,5 @@
       INTEGER itap,ind1,l,ig,iter,k 
       INTEGER iflag_topthermals, niter
-
+      LOGICAL falseklon(klon)
 
       REAL zqsatth(klon), zqsatenv(klon), zqsatenvonly(klon)
@@ -1619,5 +1619,5 @@
       REAL IntJ,IntI1,IntI2,IntI3,IntJ_CF,IntI1_CF,IntI3_CF,coeffqlenv,coeffqlth
       REAL zdelta,qsatbef,zcor
-      REAL Tbefth(klon), Tbefenv(klon), Tbefenvonly(klon)
+      REAL Tbefth(klon), Tbefenv(klon), Tbefenvonly(klon), rhoth(klon)
       REAL qlbef
       REAL dqsatenv(klon), dqsatth(klon), dqsatenvonly(klon)
@@ -1689,4 +1689,5 @@
       qlth(:,ind2)=0.
       qith(:,ind2)=0.
+      with(:,ind2)=0.
       rneb(:,:)=0.
       qcloud(:)=0.
@@ -1697,4 +1698,5 @@
       cenv_vol(:,:)=0.
       ctot_vol(:,:)=0.
+      falseklon(:)=.false.
       qsatmmussig1=0.
       qsatmmussig2=0.
@@ -1795,4 +1797,5 @@
 Tbefth(:)=ztla(:,ind2)*zpspsk(:,ind2)
 Tbefenvonly(:)=temp(:,ind2)
+rhoth(:)=paprs(:,ind2)/Tbefth(:)/RD
 
 zqenv(:)=(po(:)-fraca(:,ind2)*zqta(:,ind2))/(1.-fraca(:,ind2)) !qt = a*qtth + (1-a)*qtenv 
@@ -1989,5 +1992,5 @@
             ENDIF
 
-            CALL ICE_MPC_BL_CLOUDS(ind1,ind2,klev,Ni,Ei,C_cap,d_top,iflag_topthermals,temp_mpc,pres_mpc,zqta(ind1,:),qsith(ind1,:),qlth(ind1,:),deltazlev_mpc,snowf_mpc,fraca_mpc,qith(ind1,:))
+            CALL ICE_MPC_BL_CLOUDS(ind1,ind2,klev,Ni,Ei,C_cap,d_top,iflag_topthermals,temp_mpc,pres_mpc,zqta(ind1,:),qsith(ind1,:),qlth(ind1,:),deltazlev_mpc,with(ind1,:),fraca_mpc,qith(ind1,:))
 
             ! qmax calculation
@@ -2229,5 +2232,9 @@
 
 
-    ENDDO       !loop on klon 
+    ENDDO       !loop on klon
+
+    ! Calcule ice fall velocity in thermals
+
+    CALL FALLICE_VELOCITY(klon,qith(:,ind2),Tbefth(:),rhoth(:),paprs(:,ind2),falseklon(:),with(:,ind2))
 
 RETURN
@@ -2237,5 +2244,5 @@
 
 !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-SUBROUTINE ICE_MPC_BL_CLOUDS(ind1,ind2,klev,Ni,Ei,C_cap,d_top,iflag_topthermals,temp,pres,qth,qsith,qlth,deltazlev,snowf,fraca,qith)
+SUBROUTINE ICE_MPC_BL_CLOUDS(ind1,ind2,klev,Ni,Ei,C_cap,d_top,iflag_topthermals,temp,pres,qth,qsith,qlth,deltazlev,with,fraca,qith)
 
 ! parameterization of ice for boundary
@@ -2297,5 +2304,4 @@
 !=============================================================================
 
-    USE lscp_tools_mod, ONLY: CALC_QSAT_ECMWF
     USE ioipsl_getin_p_mod, ONLY : getin_p
     USE phys_state_var_mod, ONLY : fm_therm, detr_therm, entr_therm
@@ -2318,5 +2324,5 @@
     REAL,  DIMENSION(klev), INTENT(IN) :: qlth       ! condensed liquid water in thermals, approximated value [kg/kg]
     REAL,  DIMENSION(klev), INTENT(IN) :: deltazlev  ! layer thickness [m]
-    REAL,  DIMENSION(klev+1), INTENT(IN) :: snowf      ! snow flux at the upper inferface
+    REAL,  DIMENSION(klev), INTENT(IN) :: with       ! ice crystal fall velocity [m/s]
     REAL,  DIMENSION(klev+1), INTENT(IN) :: fraca      ! fraction of the mesh covered by thermals
     REAL,  DIMENSION(klev), INTENT(INOUT) :: qith       ! condensed ice water , thermals [kg/kg]
@@ -2396,6 +2402,6 @@
     fp1=0.
     IF (fraca(ind2p1) .GT. 0.) THEN
-    fp2=-snowf(ind2p2)/fraca(ind2p1) ! flux defined positive upward
-    fp1=-snowf(ind2p1)/fraca(ind2p1)
+    fp2=-qith(ind2p2)*rho(ind2p2)*with(ind2p2)*fraca(ind2p2)! flux defined positive upward
+    fp1=-qith(ind2p1)*rho(ind2p1)*with(ind2p1)*fraca(ind2p1)
     ENDIF
 
Index: LMDZ6/trunk/libf/phylmd/conf_phys_m.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/conf_phys_m.F90	(revision 4113)
+++ LMDZ6/trunk/libf/phylmd/conf_phys_m.F90	(revision 4114)
@@ -182,5 +182,5 @@
     INTEGER,SAVE :: iflag_cloudth_vert_omp
     INTEGER,SAVE :: iflag_rain_incloud_vol_omp
-    INTEGER,SAVE :: iflag_vice_omp
+    INTEGER,SAVE :: iflag_vice_omp, iflag_rei_omp
     REAL,SAVE :: rad_froid_omp, rad_chau1_omp, rad_chau2_omp
     REAL,SAVE :: t_glace_min_omp, t_glace_max_omp
@@ -255,4 +255,6 @@
     LOGICAL, SAVE :: ok_new_lscp_omp
     LOGICAL, SAVE :: ok_icefra_lscp_omp
+    LOGICAL, SAVE :: ok_radliq_snow_omp
+
 
     INTEGER, INTENT(OUT):: read_climoz ! read ozone climatology, OpenMP shared
@@ -1501,4 +1503,13 @@
     CALL getin('iflag_vice',iflag_vice_omp)
 
+    !Config Key  = iflag_rei
+    !Config Desc =  
+    !Config Def  = 0
+    !Config Help = 
+    !
+    iflag_rei_omp = 0
+    CALL getin('iflag_rei',iflag_rei_omp)
+
+
     !
     !Config Key  = iflag_ice_thermo
@@ -2366,5 +2377,11 @@
 
 
-
+    ok_radliq_snow_omp = .FALSE.
+    CALL getin('ok_radliq_snow', ok_radliq_snow_omp)
+    !
+    !Config Key  = ok_radliq_snow_omp
+    !Config Desc = take into account snowfall for radiation
+    !Config Def  = .FALSE.
+    !Config Help = ...
 
     ecrit_LES_omp = 1./8.
@@ -2488,4 +2505,5 @@
     iflag_rain_incloud_vol=iflag_rain_incloud_vol_omp
     iflag_vice=iflag_vice_omp
+    iflag_rei=iflag_rei_omp
     iflag_ice_thermo = iflag_ice_thermo_omp
     ok_ice_sursat = ok_ice_sursat_omp
@@ -2690,4 +2708,5 @@
     ok_new_lscp = ok_new_lscp_omp
     ok_icefra_lscp=ok_icefra_lscp_omp
+    ok_radliq_snow=ok_radliq_snow_omp
     read_fco2_ocean_cor = read_fco2_ocean_cor_omp
     var_fco2_ocean_cor = var_fco2_ocean_cor_omp
@@ -2915,4 +2934,5 @@
     WRITE(lunout,*) ' iflag_rain_incloud_vol = ',iflag_rain_incloud_vol
     WRITE(lunout,*) ' iflag_vice = ',iflag_vice
+    WRITE(lunout,*) ' iflag_rei = ',iflag_rei
     WRITE(lunout,*) ' iflag_ice_thermo = ',iflag_ice_thermo
     WRITE(lunout,*) ' ok_ice_sursat = ',ok_ice_sursat
@@ -3028,4 +3048,5 @@
     WRITE(lunout,*) ' ok_new_lscp = ', ok_new_lscp
     WRITE(lunout,*) ' ok_icefra_lscp = ', ok_icefra_lscp
+    WRITE(lunout,*) ' ok_radliq_snow = ', ok_radliq_snow
     WRITE(lunout,*) ' read_climoz = ', read_climoz
     WRITE(lunout,*) ' carbon_cycle_tr = ', carbon_cycle_tr
Index: LMDZ6/trunk/libf/phylmd/lscp_mod.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/lscp_mod.F90	(revision 4113)
+++ LMDZ6/trunk/libf/phylmd/lscp_mod.F90	(revision 4114)
@@ -208,8 +208,4 @@
   !$OMP THREADPRIVATE(rain_int_min)
 
-  LOGICAL, SAVE :: ok_radliq_precip=.false.                         ! Inclusion of all precipitation in radliq (cloud water seen by radiation)
-  !$OMP THREADPRIVATE(ok_radliq_precip)
-
-
 
 
@@ -232,9 +228,9 @@
   REAL qcloud(klon), icefrac_mpc(klon,klev), qincloud_mpc(klon)
   REAL zrfl(klon), zrfln(klon), zqev, zqevt 
-  REAL zifl(klon), zifln(klon), zqev0,zqevi, zqevti
+  REAL zifl(klon), zifln(klon), ziflprev(klon),zqev0,zqevi, zqevti
   REAL zoliq(klon), zcond(klon), zq(klon), zqn(klon)
   REAL zoliql(klon), zoliqi(klon)
   REAL zt(klon)
-  REAL zdz(klon),zrho(klon),iwc(klon)
+  REAL zdz(klon),zrho(klon,klev),iwc(klon)
   REAL zchau,zfroi,zfice(klon),zneb(klon),znebprecip(klon)
   REAL zmelt,zrain,zsnow,zprecip
@@ -335,10 +331,8 @@
     CALL getin_p('seuil_neb',seuil_neb)
     CALL getin_p('rain_int_min',rain_int_min) 
-    CALL getin_p('ok_radliq_precip',ok_radliq_precip)
     WRITE(lunout,*) 'lscp, ninter:', ninter
     WRITE(lunout,*) 'lscp, iflag_evap_prec:', iflag_evap_prec
     WRITE(lunout,*) 'lscp, seuil_neb:', seuil_neb
     WRITE(lunout,*) 'lscp, rain_int_min:', rain_int_min
-    WRITE(lunout,*) 'lscp, ok_radliq_precip:', ok_radliq_precip
 
     ! check for precipitation sub-time steps
@@ -390,7 +384,12 @@
 rain(:) = 0.0
 snow(:) = 0.0
-zoliq(:)=0.
+zoliq(:)=0.0
+zfice(:)=0.0
+dzfice(:)=0.0
+zqprecl(:)=0.0
+zqpreci(:)=0.0
 zrfl(:) = 0.0
 zifl(:) = 0.0
+ziflprev(:)=0.0
 zneb(:) = seuil_neb
 zrflclr(:) = 0.0                                                                            
@@ -944,6 +943,5 @@
 
     ! ----------------------------------------------------------------
-    ! P3> Precipitation formation and calculation of condensed
-    !     water seen by the radiation scheme
+    ! P3> Precipitation formation 
     ! ----------------------------------------------------------------
     
@@ -1001,6 +999,6 @@
             zoliqi(i)= zoliq(i)*zfice(i)
             zoliql(i)= zoliq(i)*(1.-zfice(i))
-            zrho(i)  = pplay(i,k) / zt(i) / RD
-            zdz(i)   = (paprs(i,k)-paprs(i,k+1)) / (zrho(i)*RG)
+            zrho(i,k)  = pplay(i,k) / zt(i) / RD
+            zdz(i)   = (paprs(i,k)-paprs(i,k+1)) / (zrho(i,k)*RG)
             iwc(i)   = 0. 
             zneb(i)  = MAX(rneb(i,k),seuil_neb)
@@ -1012,7 +1010,5 @@
 
     ! -------------------------------------------------------------------------------
-    ! Iterations to calculate a "mean" cloud water content during the precipitation
-    ! Comment: it is not the remaining water after precipitation but a mean
-    ! remaining water in the cloud during the time step that is seen by the radiation
+    ! Autoconversion
     ! -------------------------------------------------------------------------------
      
@@ -1021,9 +1017,9 @@
         DO i=1,klon
             IF (rneb(i,k).GT.0.0) THEN
-                iwc(i) = zrho(i) * zoliqi(i) / zneb(i) ! in-cloud ice condensate content
+                iwc(i) = zrho(i,k) * zoliqi(i) / zneb(i) ! in-cloud ice condensate content
             ENDIF
         ENDDO
 
-        CALL FALLICE_VELOCITY(klon,iwc(:),zt(:),zrho(:),pplay(:,k),ptconv(:,k),velo(:,k))
+        CALL FALLICE_VELOCITY(klon,iwc(:),zt(:),zrho(:,k),pplay(:,k),ptconv(:,k),velo(:,k))
 
         DO i = 1, klon
@@ -1088,25 +1084,11 @@
 
     
-    ! Include the contribution to non-evaporated precipitation to radliq 
-    IF ((ok_radliq_precip) .AND. (k .LT. klev)) THEN
-        ! for rain drops, we assume a fallspeed of 5m/s
-        vr=5.0
-        radliql(:,k)=radliql(:,k)+zrfl(:)/vr/zrho(:)
-        ! for ice crystals, we take the fallspeed from level above 
-        radliqi(:,k)=radliqi(:,k)+zifl(:)/zrho(:)/velo(:,k+1)
-        radliq(:,k)=radliql(:,k)+radliqi(:,k)
-    ENDIF
-
-    ! caculate the percentage of ice in "radliq" so cloud+precip seen by the radiation scheme
-    DO i=1,klon
-        IF (radliq(i,k) .GT. 0.) THEN
-            radicefrac(i,k)=MIN(MAX(radliqi(i,k)/radliq(i,k),0.),1.)
-        ENDIF
-    ENDDO
-
 
     ! Precipitation flux calculation
 
     DO i = 1, klon
+
+
+            ziflprev(i)=zifl(i)
 
             IF (rneb(i,k) .GT. 0.0) THEN
@@ -1144,5 +1126,4 @@
                     ! iced water budget
                     zqpreci(i) = max (zqpreci(i) - Deltaqprecl - Deltaq, 0.)
-
            
                 IF (iflag_evap_prec.EQ.4) THEN                                                            
@@ -1163,5 +1144,9 @@
            ENDIF ! rneb>0
 
+
    ENDDO
+
+
+
 
     ! LTP: limit of surface cloud fraction covered by precipitation when the local intensity of the flux is below rain_int_min                                                                              
@@ -1189,5 +1174,4 @@
     ENDIF  
 
-    ! --------------------------------
     ! End of precipitation formation
     ! --------------------------------
@@ -1205,4 +1189,34 @@
     ENDDO
 
+    ! Calculation of the concentration of condensates seen by the radiation scheme
+    ! for liquid phase, we take radliql
+    ! for ice phase, we take radliqi if we neglect snowfall, otherwise (ok_radliq_snow=true) 
+    ! we recaulate radliqi to account for contributions from the precipitation flux
+
+
+    IF ((ok_radliq_snow) .AND. (k .LT. klev)) THEN
+        ! for the solid phase (crystals + snowflakes)
+        ! we recalculate radliqi by summing
+        ! the ice content calculated in the mesh
+        ! + the contribution of the non-evaporated snowfall 
+        ! from the overlying layer
+        DO i=1,klon
+           IF (ziflprev(i) .NE. 0.0) THEN
+              radliqi(i,k)=zoliq(i)*zfice(i)+zqpreci(i)+ziflprev(i)/zrho(i,k+1)/velo(i,k+1)
+           ELSE
+              radliqi(i,k)=zoliq(i)*zfice(i)+zqpreci(i)  
+           ENDIF
+           radliq(i,k)=radliql(i,k)+radliqi(i,k)
+        ENDDO
+    ENDIF
+
+    ! caculate the percentage of ice in "radliq" so cloud+precip seen by the radiation scheme
+    DO i=1,klon
+        IF (radliq(i,k) .GT. 0.) THEN
+            radicefrac(i,k)=MIN(MAX(radliqi(i,k)/radliq(i,k),0.),1.)
+        ENDIF
+    ENDDO
+
+
 
     ! ----------------------------------------------------------------
Index: LMDZ6/trunk/libf/phylmd/newmicro.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/newmicro.F90	(revision 4113)
+++ LMDZ6/trunk/libf/phylmd/newmicro.F90	(revision 4114)
@@ -3,5 +3,5 @@
 SUBROUTINE newmicro(flag_aerosol, ok_cdnc, bl95_b0, bl95_b1, paprs, pplay, t, pqlwp, picefra, pclc, &
     pcltau, pclemi, pch, pcl, pcm, pct, pctlwp, xflwp, xfiwp, xflwc, xfiwc, &
-    mass_solu_aero, mass_solu_aero_pi, pcldtaupi, re, fl, reliq, reice, &
+    mass_solu_aero, mass_solu_aero_pi, pcldtaupi, latitude_deg,re, fl, reliq, reice, &
     reliq_pi, reice_pi)
 
@@ -31,6 +31,5 @@
 
   ! t-------input-R-temperature
-  ! pqlwp---input-R-eau liquide nuageuse dans l'atmosphere dans la partie
-  ! nuageuse (kg/kg)
+  ! pqlwp---input-R-eau liquide nuageuse dans l'atmosphere dans la maille (kg/kg)
   ! picefra--input-R-fraction de glace dans les nuages
   ! pclc----input-R-couverture nuageuse pour le rayonnement (0 a 1)
@@ -41,4 +40,5 @@
   ! bl95_b0-input-R-a PARAMETER, may be varied for tests (s-sea, l-land)
   ! bl95_b1-input-R-a PARAMETER, may be varied for tests (    -"-      )
+  ! latitude_deg-input latitude in degrees
 
   ! re------output-R-Cloud droplet effective radius multiplied by fl [um]
@@ -89,4 +89,5 @@
   REAL pclemi(klon, klev)
   REAL pcldtaupi(klon, klev)
+  REAL latitude_deg(klon)
 
   REAL pct(klon)
@@ -128,5 +129,5 @@
   REAL, PARAMETER :: t_glace_max_old = 273.13
 
-  REAL rel, tc, rei
+  REAL rel, tc, rei, iwc, dei, deimin, deimax
   REAL k_ice0, k_ice, df
   PARAMETER (k_ice0=0.005) ! units=m2/g
@@ -339,7 +340,32 @@
             rhodz(i, k)
           zfiwp_var = 1000.*zfice(i, k)*pqlwp(i, k)/pclc(i, k)*rhodz(i, k)
-          tc = t(i, k) - 273.15
-          rei = d_rei_dt*tc + rei_max
-          IF (tc<=-81.4) rei = rei_min
+          ! Calculation of ice cloud effective radius in micron
+          IF (iflag_rei .EQ. 1) THEN
+            ! when we account for precipitation in the radiation scheme,
+            ! It is recommended to use the rei formula from Sun and Rikkus 1999 with a revision
+            ! from Sun 2001 (as in the IFS model)
+            iwc=zfice(i, k)*pqlwp(i, k)/pclc(i,k)*zrho(i,k)*1000. !in cloud ice water content in g/m3
+            dei=(1.2351+0.0105*(t(i,k)-273.15))*(45.8966*(iwc**0.2214) + &
+               & 0.7957*(iwc**0.2535)*(t(i,k)-83.15))
+            !deimax=155.0
+            !deimin=20.+40*cos(abs(latitude_deg(i))/180.*RPI)
+            !Etienne: deimax and deimin controled by rei_max and rei_min in physiq.def
+            deimax=rei_max*2.0
+            deimin=2.0*rei_min+40*cos(abs(latitude_deg(i))/180.*RPI) 
+            dei=min(dei,deimax)
+            dei=max(dei,deimin)
+            rei=3.*sqrt(3.)/8.*dei
+           ELSE
+            ! Default
+            ! for ice clouds: as a function of the ambiant temperature
+            ! [formula used by Iacobellis and Somerville (2000), with an
+            ! asymptotical value of 3.5 microns at T<-81.4 C added to be
+            ! consistent with observations of Heymsfield et al. 1986]:
+            ! 2011/05/24 : rei_min = 3.5 becomes a free PARAMETER as well as
+            ! rei_max=61.29
+            tc = t(i, k) - 273.15
+            rei = d_rei_dt*tc + rei_max
+            IF (tc<=-81.4) rei = rei_min
+           ENDIF
 
           ! -- cloud optical thickness :
@@ -419,15 +445,34 @@
         rel = rad_chaud(i, k)
 
-        ! for ice clouds: as a function of the ambiant temperature
-        ! [formula used by Iacobellis and Somerville (2000), with an
-        ! asymptotical value of 3.5 microns at T<-81.4 C added to be
-        ! consistent with observations of Heymsfield et al. 1986]:
-        ! 2011/05/24 : rei_min = 3.5 becomes a free PARAMETER as well as
-        ! rei_max=61.29
-
-        tc = t(i, k) - 273.15
-        rei = d_rei_dt*tc + rei_max
-        IF (tc<=-81.4) rei = rei_min
-
+        ! Calculation of ice cloud effective radius in micron
+
+
+        IF (iflag_rei .GT. 0) THEN
+
+            ! when we account for precipitation in the radiation scheme,
+            ! we use the rei formula from Sun and Rikkus 1999 with a revision
+            ! from Sun 2001 (as in the IFS model)
+            iwc=zfice(i, k)*pqlwp(i, k)/pclc(i,k)*zrho(i,k)*1000. !in cloud ice water content in g/m3
+            dei=(1.2351+0.0105*(t(i,k)-273.15))*(45.8966*(iwc**0.2214) + &
+               &0.7957*(iwc**0.2535)*(t(i,k)-83.15))
+            
+            deimax=155.0
+            deimin=20.+40*cos(abs(latitude_deg(i))/180.*RPI)
+            dei=min(dei,deimax)
+            dei=max(dei,deimin)
+            rei=3.*sqrt(3.)/8.*dei
+       
+        ELSE
+            ! Default
+            ! for ice clouds: as a function of the ambiant temperature
+            ! [formula used by Iacobellis and Somerville (2000), with an
+            ! asymptotical value of 3.5 microns at T<-81.4 C added to be
+            ! consistent with observations of Heymsfield et al. 1986]:
+            ! 2011/05/24 : rei_min = 3.5 becomes a free PARAMETER as well as
+            ! rei_max=61.29
+            tc = t(i, k) - 273.15
+            rei = d_rei_dt*tc + rei_max
+            IF (tc<=-81.4) rei = rei_min
+        ENDIF
         ! -- cloud optical thickness :
         ! [for liquid clouds, traditional formula,
Index: LMDZ6/trunk/libf/phylmd/nuage.h
===================================================================
--- LMDZ6/trunk/libf/phylmd/nuage.h	(revision 4113)
+++ LMDZ6/trunk/libf/phylmd/nuage.h	(revision 4114)
@@ -12,6 +12,6 @@
       INTEGER iflag_rain_incloud_vol
    
-      INTEGER iflag_mpc_bl, iflag_gammasat, iflag_vice
-      LOGICAL ok_icefra_lscp
+      INTEGER iflag_mpc_bl, iflag_gammasat, iflag_vice, iflag_rei
+      LOGICAL ok_icefra_lscp, ok_radliq_snow
 
       common /nuagecom/ rad_froid,rad_chau1, rad_chau2,t_glace_max,     &
@@ -21,5 +21,6 @@
      &                  iflag_t_glace,iflag_cloudth_vert,iflag_cld_cv,  &
      &                  iflag_rain_incloud_vol,                         &
-     &                  ok_icefra_lscp,                                 &
-     &                  iflag_mpc_bl, iflag_gammasat, iflag_vice    
+     &                  ok_icefra_lscp,ok_radliq_snow,                  &
+     &                  iflag_mpc_bl, iflag_gammasat, iflag_vice,       &
+     &                  iflag_rei    
 !$OMP THREADPRIVATE(/nuagecom/)
Index: LMDZ6/trunk/libf/phylmd/phys_local_var_mod.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/phys_local_var_mod.F90	(revision 4113)
+++ LMDZ6/trunk/libf/phylmd/phys_local_var_mod.F90	(revision 4114)
@@ -438,5 +438,5 @@
       REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: cldemi, cldfra, cldtau, fiwc, fl, re, flwc
 !$OMP THREADPRIVATE(cldemi, cldfra, cldtau, fiwc, fl, re, flwc)
-      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: qlth, qith, qsith
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: qlth, qith, qsith, with
 !$OMP THREADPRIVATE(qlth, qith, qsith)
       REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: ref_liq, ref_ice, theta, zphi
@@ -778,5 +778,5 @@
       ALLOCATE(rain_lsc(klon))
       ALLOCATE(rain_num(klon))
-      ALLOCATE(qlth(klon,klev), qith(klon,klev), qsith(klon,klev))
+      ALLOCATE(qlth(klon,klev), qith(klon,klev), qsith(klon,klev), with(klon,klev))
       !
       ALLOCATE(sens_x(klon), sens_w(klon))
@@ -1089,5 +1089,5 @@
       DEALLOCATE(rain_lsc)
       DEALLOCATE(rain_num)
-      DEALLOCATE(qlth, qith, qsith)
+      DEALLOCATE(qlth, qith, qsith, with)
 !
       DEALLOCATE(sens_x, sens_w)
Index: LMDZ6/trunk/libf/phylmd/physiq_mod.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/physiq_mod.F90	(revision 4113)
+++ LMDZ6/trunk/libf/phylmd/physiq_mod.F90	(revision 4114)
@@ -4125,5 +4125,5 @@
                flwp, fiwp, flwc, fiwc, &
                mass_solu_aero, mass_solu_aero_pi, &
-               cldtaupi, re, fl, ref_liq, ref_ice, &
+               cldtaupi, latitude_deg, re, fl, ref_liq, ref_ice, &
                ref_liq_pi, ref_ice_pi)
        ELSE